c@a
c@versb
C-----------------------------------------------------------------------
C
CVERS                  Code_Saturne version 1.3
C                      ------------------------
C
C     This file is part of the Code_Saturne Kernel, element of the
C     Code_Saturne CFD tool.
C
C     Copyright (C) 1998-2008 EDF S.A., France
C
C     contact: saturne-support@edf.fr
C
C     The Code_Saturne Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The Code_Saturne Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
c@verse
                        SUBROUTINE USALIN
C                       *****************
C***********************************************************************
C  FONCTION  :
C  ---------
c@foncb
CFONC
CFONC  ROUTINE UTILISATEUR POUR ENTREE
CFONC    DES PARAMETRES DE DE L'ALE
CFONC
c@fonce
C-----------------------------------------------------------------------
C                             ARGUMENTS
c@argub
CARGU .______________.____._____.______________________________________.
CARGU !    NOM       !TYPE!MODE !                   ROLE               !
CARGU !______________!____!_____!______________________________________!
CARGU !______________!____!_____!______________________________________!
c@argue
C
c@commb
CCOMM                             COMMONS
CCOMM .______________.____._____.______________________________________.
CCOMM !    NOM       !TYPE!MODE !                   ROLE               !
CCOMM !______________!____!_____!______________________________________!
CCOMM !______________!____!_____!______________________________________!
c@comme
C
C     TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C            L (LOGIQUE)   .. ET TYPES COMPOSES (EX : TR TABLEAU REEL)
C     MODE : -> DONNEE, <- RESULTAT, <-> DONNEE MODIFIEE,
C            - TABLEAU DE TRAVAIL
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON
C***********************************************************************
C
C
      INCLUDE "paramx.h"
      INCLUDE "optcal.h"
      INCLUDE "albase.h"
C
C
C***********************************************************************
C
C ARGUMENTS
C
C
C VARIABLES LOCALES
C
C
C***********************************************************************
C
C
C TEST_A_ENLEVER_POUR_UTILISER_LE_SOUS_PROGRAMME_FIN
C
C=======================================================================
C
C
C     CE SOUS-PROGRAMME PERMET DE RENSEIGNER LES PARAMETRES
C
C       SPECIFIQUES AU MODULE ALE
C
C
C     IL EST POSSIBLE D'AJOUTER OU DE RETRANCHER DES PARAMETRES
C
C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
CexC
CexC     SI L'ON    DISPOSE     DE L'INTERFACE DE CODE_SATURNE :
CexC
CexC       on trouvera ci-dessous des exemples commentes.
CexC
CexC       L'utilisateur pourra, si necessaire, les decommenter et les
CexC       adapter a ses besoins.
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin
C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
Cex
CexC --- Activation de la methode ALE
Cex      IALE = 1
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin

C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
CexC
CexC --- Nombre de sous-iterations d'initialisation du fluide. Dans le cas
CexC     d'un calcul suite, il s'agit du nombre d'iterations a partir du
CexC     debut de l'iteration en cours (i.e. pas un nombre absolu).
CexC     Dans le cas general, NALINF = 0 pour une suite de calcul.
CexC
Cex        NALINF = 75
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin
C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
CexC
CexC --- Nombre maximal d'iterations d'implicitation du deplacement des
CexC     structures (=1 pour le couplage explicite)
Cex      NALIMX = 15
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin
C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
CexC
CexC --- Precision relative d'implicitation du deplacement des structures
Cex      EPALIM = 1.D-5
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin
C
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_debut
CexC
CexC --- Type de viscosite de maillage (cf. usvima)
CexC     0 : isotrope
CexC     1 : orthotrope
Cex      IORTVM = 0
CexC
CexC CODE_FOURNI_COMME_EXEMPLE_A_ADAPTER_PAR_L_UTILISATEUR_fin
C
C----
C FORMATS
C----
C
C
C
      RETURN
      END
c@z

