c     @a
c     @versb
C-----------------------------------------------------------------------
C     
C     VERS                  Code_Saturne version 1.3
C     ------------------------
C     
C     This file is part of the Code_Saturne Kernel, element of the
C     Code_Saturne CFD tool.
C     
C     Copyright (C) 1998-2007 EDF S.A., France
C     
C     contact: saturne-support@edf.fr
C     
C     The Code_Saturne Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C     
C     The Code_Saturne Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C     
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C     
C-----------------------------------------------------------------------
c     @verse
      SUBROUTINE USPROJ
C     *****************
C     -------------------------------------------------------------
     &     ( IDBIA0 , IDBRA0 ,
     &     NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML,
     &     NNOD   , LNDFAC , LNDFBR , NCELBR ,
     &     NVAR   , NSCAL  , NPHAS  ,
     &     NBPMAX , NVP    , NVEP   , NIVEP  , NTERSL , NVLSTA , NVISBR,
     &     NIDEVE , NRDEVE , NITUSE , NRTUSE ,
     &     IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML , MAXELT , LSTELT,
     &     IPNFAC , NODFAC , IPNFBR , NODFBR , ITEPA  ,
     &     IDEVEL , ITUSER , IA     ,
     &     XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME,
     &     DT     , RTPA   , RTP    , PROPCE , PROPFA , PROPFB ,
     &     COEFA  , COEFB  ,
     &     ETTP   , ETTPA  , TEPA   , STATIS , STATIV , TSLAGR , PARBOR,
     &     RDEVEL , RTUSER , RA     )
C     -------------------------------------------------------------
C***********************************************************************
C     FONCTION :
C     --------
c     @foncb
C     FONC
C     FONC MODIFICATION UTILISATEUR EN FIN DE PAS DE TEMPS
C     FONC    TOUT EST POSSIBLE,
C     FONC
C     FONC
C     FONC ON DONNE ICI PLUSIEURS EXEMPLES :
C     FONC
C     FONC   - CALCUL DE BILAN THERMIQUE
C     FONC     (au besoin, voir "ADAPTATION A UN SCALAIRE QUELCONQUE")
C     FONC
C     FONC   - MODIFICATION ARBITRAIRE D'UNE VARIABLE DE CALCUL
C     FONC
C     FONC   - EXTRACTION D'UN PROFIL 1D
C     FONC
C     FONC   - IMPRESSION D'UN MOMENT
C     FONC
C     FONC   - EXEMPLES D'UTILISATION DES ROUTINES DE PARALLELISME
C     FONC
C     FONC CES EXEMPLES SONT DONNES EN SUPPOSANT UN CAS AVEC PERIODICITE
C     FONC   (IPERIO.GT.0) ET PARALLELISME (IRANGP.GE.0).
C     FONC
C     FONC
C     FONC LE CALCUL DE BILAN THERMIQUE FOURNIT EN OUTRE UNE TRAME POUR
C     FONC   PLUSIEURS CHOSES
C     FONC   - CALCUL DE GRADIENT (AVEC LES PRECAUTIONS UTILES EN PARALLELE ET
C     FONC     PERIODIQUE)
C     FONC   - CALCUL DE GRANDEUR DEPENDANT DES VALEURS AUX CELLULES VOISINES
C     FONC     D'UNE FACE (AVEC LES PRECAUTIONS A PRENDRE EN PARALLELE ET
C     FONC     PERIODIQUE : VOIR L'ECHANGE DE DT ET DE CP)
C     FONC   - CALCUL D'UNE SOMME SUR LES PROCESSEURS LORS D'UN CALCUL
C     FONC     PARALLELE (PARSOM)
C     FONC
C     FONC
C     FONC IDENTIFICATION DES CELLULES/FACES DE BORD/FACES INTERNES
C     FONC ========================================================
C     FONC
C     FONC   Les commandes GETCEL, GETFBR et GETFAC permettent d'identifier
C     FONC   respectivement les cellules, faces ou faces de bord en fonction
C     FONC   de differents criteres.
C     FONC
C     FONC   GETCEL(CHAINE,NLELT,LSTELT) :
C     FONC   - CHAINE est une chaine de caractere fournie par l'utilisateur
C     FONC     qui donne les criteres de selection
C     FONC   - NLTELT est renvoye par la commande. C'est un entier qui
C     FONC     correspond au nombre de cellules trouveees repondant au
C     FONC     critere
C     FONC   - LSTELT est renvoye par la commande. C'est un tableau d'entiers
C     FONC     de taille NLTELT donnant la liste des cellules trouvees
C     FONC     repondant au critere.
C     FONC
C     FONC   CHAINE peut etre constitue de :
C     FONC   - references de couleurs (ex. : 1, 8, 26, ...
C     FONC   - references de groupes (ex. : entrees, groupe1, ...)
C     FONC   - criteres geometriques (ex. X<0.1, Y>=0.25, ...)
C     FONC   Ces criteres peuvent etre combines par des operateurs logiques
C     FONC   (AND et OR) et des parentheses
C     FONC   ex. : '1 AND (groupe2 OR groupe3) AND Y<1' permettra de recuperer
C     FONC   les cellules de couleur 1, appartenant aux groupes 'groupe2'
C     FONC   ou 'groupe3' et de coordonnee Y inferieure a 1.
C     FONC
C     FONC   La syntaxe des commandes GETFBR et GETFAC est identique.
C     FONC
C     FONC
c     @fonce
C-----------------------------------------------------------------------
C     ARGUMENTS
c     @argub
C     ARGU .______________.____._____.______________________________________.
C     ARGU !    NOM       !TYPE!MODE !                   ROLE               !
C     ARGU !______________!____!_____!______________________________________!
C     ARGU ! IDBIA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS IA !
C     ARGU ! IDBRA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS RA !
C     ARGU ! NDIM         ! E  !  -> ! DIMENSION DE L'ESPACE                !
C     ARGU ! NCELET       ! E  !  -> ! NOMBRE D'ELEMENTS HALO COMPRIS       !
C     ARGU ! NCEL         ! E  !  -> ! NOMBRE D'ELEMENTS ACTIFS             !
C     ARGU ! NFAC         ! E  !  -> ! NOMBRE DE FACES INTERNES             !
C     ARGU ! NFABOR       ! E  !  -> ! NOMBRE DE FACES DE BORD              !
C     ARGU ! NFML         ! E  !  -> ! NOMBRE DE FAMILLES D ENTITES         !
C     ARGU ! NPRFML       ! E  !  -> ! NOMBRE DE PROPRIETESE DES FAMILLES   !
C     ARGU ! NNOD         ! E  !  -> ! NOMBRE DE SOMMETS                    !
C     ARGU ! LNDFAC       ! E  !  -> ! LONGUEUR DU TABLEAU NODFAC (OPTIONNEL!
C     ARGU ! LNDFBR       ! E  !  -> ! LONGUEUR DU TABLEAU NODFBR (OPTIONNEL!
C     ARGU ! NCELBR       ! E  !  -> ! NOMBRE D'ELEMENTS AYANT AU MOINS UNE !
C     ARGU !              !    !     ! FACE DE BORD                         !
C     ARGU ! NVAR         ! E  !  -> ! NOMBRE TOTAL DE VARIABLES            !
C     ARGU ! NSCAL        ! E  !  -> ! NOMBRE TOTAL DE SCALAIRES            !
C     ARGU ! NPHAS        ! E  !  -> ! NOMBRE DE PHASES                     !
C     ARGU ! NBPMAX       ! E  !  -> ! NOMBRE MAX DE PARTICULES AUTORISE    !
C     ARGU ! NVP          ! E  !  -> ! NOMBRE DE VARIABLES PARTICULAIRES    !
C     ARGU ! NVEP         ! E  !  -> ! NOMBRE INFO PARTICULAIRES (REELS)    !
C     ARGU ! NIVEP        ! E  !  -> ! NOMBRE INFO PARTICULAIRES (ENTIERS)  !
C     ARGU ! NTERSL       ! E  !  -> ! NBR TERMES SOURCES DE COUPLAGE RETOUR!
C     ARGU ! NVLSTA       ! E  !  -> ! NOMBRE DE VAR STATISTIQUES LAGRANGIEN!
C     ARGU ! NVISBR       ! E  !  -> ! NOMBRE DE STATISTIQUES AUX FRONTIERES!
C     ARGU ! NIDEVE NRDEVE! E  !  -> ! LONGUEUR DE IDEVEL RDEVEL            !
C     ARGU ! NITUSE NRTUSE! E  !  -> ! LONGUEUR DE ITUSER RTUSER            !
C     ARGU ! IFACEL       ! TE !  -> ! ELEMENTS VOISINS D'UNE FACE INTERNE  !
C     ARGU ! (2, NFAC)    !    !     !                                      !
C     ARGU ! IFABOR       ! TE !  -> ! ELEMENT  VOISIN  D'UNE FACE DE BORD  !
C     ARGU ! (NFABOR)     !    !     !                                      !
C     ARGU ! IFMFBR       ! TE !  -> ! NUMERO DE FAMILLE D'UNE FACE DE BORD !
C     ARGU ! (NFABOR)     !    !     !                                      !
C     ARGU ! IFMCEL       ! TE !  -> ! NUMERO DE FAMILLE D'UNE CELLULE      !
C     ARGU ! (NCELET)     !    !     !                                      !
C     ARGU ! IPRFML       ! TE !  -> ! PROPRIETES D'UNE FAMILLE             !
C     ARGU ! NFML  ,NPRFML!    !     !                                      !
C     ARGU ! MAXELT       !  E !  -> ! NB MAX D'ELEMENTS (CELL,FAC,FBR)     !
C     ARGU ! LSTELT(MAXELT) TE !  -  ! TABLEAU DE TRAVAIL                   !
C     ARGU ! IPNFAC       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
C     ARGU !   (NFAC+1)   !    !     !  FACE INTERNE DANS NODFAC (OPTIONNEL)!
C     ARGU ! NODFAC       ! TE !  -> ! CONNECTIVITE FACES INTERNES/NOEUDS   !
C     ARGU !   (LNDFAC)   !    !     !  (OPTIONNEL)                         !
C     ARGU ! IPNFBR       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
C     ARGU !  (NFABOR+1)  !    !     !  FACE DE BORD DANS NODFBR (OPTIONNEL)!
C     ARGU ! NODFBR       ! TE !  -> ! CONNECTIVITE FACES DE BORD/NOEUDS    !
C     ARGU !   (LNDFBR  ) !    !     !  (OPTIONNEL)                         !
C     ARGU ! ITEPA        ! TE !  -> ! INFO PARTICULAIRES (ENTIERS)         !
C     ARGU ! (NBPMAX,NIVEP!    !     !   (CELLULE DE LA PARTICULE,...)      !
C     ARGU ! IDEVEL(NIDEVE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE DEVELOPEMT !
C     ARGU ! ITUSER(NITUSE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE UTILISATEUR!
C     ARGU ! IA(*)        ! TR !  -  ! MACRO TABLEAU ENTIER                 !
C     ARGU ! XYZCEN       ! TR !  -> ! POINT ASSOCIES AUX VOLUMES DE CONTROL!
C     ARGU ! (NDIM,NCELET !    !     !                                      !
C     ARGU ! SURFAC       ! TR !  -> ! VECTEUR SURFACE DES FACES INTERNES   !
C     ARGU ! (NDIM,NFAC)  !    !     !                                      !
C     ARGU ! SURFBO       ! TR !  -> ! VECTEUR SURFACE DES FACES DE BORD    !
C     ARGU ! (NDIM,NFABOR)!    !     !                                      !
C     ARGU ! CDGFAC       ! TR !  -> ! CENTRE DE GRAVITE DES FACES INTERNES !
C     ARGU ! (NDIM,NFAC)  !    !     !                                      !
C     ARGU ! CDGFBO       ! TR !  -> ! CENTRE DE GRAVITE DES FACES DE BORD  !
C     ARGU ! (NDIM,NFABOR)!    !     !                                      !
C     ARGU ! XYZNOD       ! TR !  -> ! COORDONNES DES NOEUDS (OPTIONNEL)    !
C     ARGU ! (NDIM,NNOD)  !    !     !                                      !
C     ARGU ! VOLUME       ! TR !  -> ! VOLUME D'UN DES NCELET ELEMENTS      !
C     ARGU ! (NCELET      !    !     !                                      !
C     ARGU ! DT(NCELET)   ! TR !  -> ! PAS DE TEMPS                         !
C     ARGU ! RTP, RTPA    ! TR !  -> ! VARIABLES DE CALCUL AU CENTRE DES    !
C     ARGU ! (NCELET,*)   !    !     !    CELLULES (INSTANT COURANT OU PREC)!
C     ARGU ! PROPCE       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
C     ARGU ! (NCELET,*)   !    !     !    CELLULES                          !
C     ARGU ! PROPFA       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
C     ARGU !  (NFAC,*)    !    !     !    FACES INTERNES                    !
C     ARGU ! PROPFB       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
C     ARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
C     ARGU ! COEFA, COEFB ! TR !  -> ! CONDITIONS AUX LIMITES AUX           !
C     ARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
C     ARGU ! ETTP         ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
C     ARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE COURANTE      !
C     ARGU ! ETTPA        ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
C     ARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE PRECEDENTE    !
C     ARGU ! TEPA         ! TR !  -> ! INFO PARTICULAIRES (REELS)           !
C     ARGU ! (NBPMAX,NVEP)!    !     !   (POIDS STATISTIQUES,...)           !
C     ARGU ! STATIS       ! TR !  -> ! MOYENNES STATISTIQUES                !
C     ARGU !(NCELET,NVLSTA!    !     !                                      !
C     ARGU ! STATIV       ! TR !  -> ! CUMUL POUR LES VARIANCES DES         !
C     ARGU !(NCELET,      !    !     !    STATISTIQUES VOLUMIQUES           !
C     ARGU !   NVLSTA-1)  !    !     !                                      !
C     ARGU ! TSLAGR       ! TR !  -> ! TERME DE COUPLAGE RETOUR DU          !
C     ARGU !(NCELET,NTERSL!    !     !   LAGRANGIEN SUR LA PHASE PORTEUSE   !
C     ARGU ! PARBOR       ! TR !  -> ! INFOS SUR INTERACTION DES PARTICULES !
C     ARGU !(NFABOR,NVISBR!    !     !   AUX FACES DE BORD                  !
C     ARGU ! RDEVEL(NRDEVE! TR ! <-> ! TAB REEL COMPLEMENTAIRE DEVELOPEMT   !
C     ARGU ! RTUSER(NRTUSE! TR ! <-> ! TAB REEL COMPLEMENTAIRE UTILISATEUR  !
C     ARGU ! RA(*)        ! TR !  -  ! MACRO TABLEAU REEL                   !
C     ARGU !______________!____!_____!______________________________________!
c     @argue
C     
c     @commb
C     COMM                             COMMONS
C     COMM .______________.____._____.______________________________________.
C     COMM !    NOM       !TYPE!MODE !                   ROLE               !
C     COMM !______________!____!_____!______________________________________!
C     COMM !______________!____!_____!______________________________________!
c     @comme
C     
C     TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C     L (LOGIQUE)   .. ET TYPES COMPOSES (EX : TR TABLEAU REEL)
C     MODE : -> DONNEE, <- RESULTAT, <-> DONNEE MODIFIEE,
C     - TABLEAU DE TRAVAIL
C***********************************************************************
C     
      IMPLICIT NONE
C     
C***********************************************************************
C     DONNEES EN COMMON
C***********************************************************************
C     
      INCLUDE "dimfbr.h"
      INCLUDE "paramx.h"
      INCLUDE "pointe.h"
      INCLUDE "numvar.h"
      INCLUDE "optcal.h"
      INCLUDE "cstphy.h"
      INCLUDE "cstnum.h"
      INCLUDE "entsor.h"
      INCLUDE "lagpar.h"
      INCLUDE "lagran.h"
      INCLUDE "parall.h"
      INCLUDE "period.h"
      INCLUDE "ppppar.h"
      INCLUDE "ppthch.h"
      INCLUDE "ppincl.h"
C     
C***********************************************************************
C     
C     ARGUMENTS
C     
      INTEGER          IDBIA0 , IDBRA0
      INTEGER          NDIM   , NCELET , NCEL   , NFAC   , NFABOR
      INTEGER          NFML   , NPRFML
      INTEGER          NNOD   , LNDFAC , LNDFBR , NCELBR
      INTEGER          NVAR   , NSCAL  , NPHAS
      INTEGER          NBPMAX , NVP    , NVEP  , NIVEP
      INTEGER          NTERSL , NVLSTA , NVISBR
      INTEGER          NIDEVE , NRDEVE , NITUSE , NRTUSE
C     
      INTEGER          IFACEL(2,NFAC) , IFABOR(NFABOR)
      INTEGER          IFMFBR(NFABOR) , IFMCEL(NCELET)
      INTEGER          IPRFML(NFML,NPRFML)
      INTEGER          MAXELT, LSTELT(MAXELT)
      INTEGER          IPNFAC(NFAC+1), NODFAC(LNDFAC)
      INTEGER          IPNFBR(NFABOR+1), NODFBR(LNDFBR)
      INTEGER          ITEPA(NBPMAX,NIVEP)
      INTEGER          IDEVEL(NIDEVE), ITUSER(NITUSE)
      INTEGER          IA(*)
C     
      DOUBLE PRECISION XYZCEN(NDIM,NCELET)
      DOUBLE PRECISION SURFAC(NDIM,NFAC), SURFBO(NDIM,NFABOR)
      DOUBLE PRECISION CDGFAC(NDIM,NFAC), CDGFBO(NDIM,NFABOR)
      DOUBLE PRECISION XYZNOD(NDIM,NNOD), VOLUME(NCELET)
      DOUBLE PRECISION DT(NCELET), RTP(NCELET,*), RTPA(NCELET,*)
      DOUBLE PRECISION PROPCE(NCELET,*)
      DOUBLE PRECISION PROPFA(NFAC,*), PROPFB(NDIMFB,*)
      DOUBLE PRECISION COEFA(NDIMFB,*), COEFB(NDIMFB,*)
      DOUBLE PRECISION ETTP(NBPMAX,NVP) , ETTPA(NBPMAX,NVP)
      DOUBLE PRECISION TEPA(NBPMAX,NVEP)
      DOUBLE PRECISION STATIS(NCELET,NVLSTA), STATIV(NCELET,NVLSTA-1)
      DOUBLE PRECISION TSLAGR(NCELET,NTERSL)
      DOUBLE PRECISION PARBOR(NFABOR,NVISBR)
      DOUBLE PRECISION RDEVEL(NRDEVE), RTUSER(NRTUSE), RA(*)
C     
C     VARIABLES LOCALES
C     
      INTEGER          IDEBIA, IDEBRA
      INTEGER          IEL    , IELG   , IFAC   , IFACG  , IVAR
      INTEGER          IEL1   , IEL2   , IELTSM
      INTEGER          IORTHO , IMPOUT
      INTEGER          IFINIA , IFINRA
      INTEGER          IGRADX , IGRADY , IGRADZ
      INTEGER          ITRAVX , ITRAVY , ITRAVZ , ITRECO
      INTEGER          INC    , ICCOCG
      INTEGER          NSWRGP , IMLIGP , IPHYDP , IWARNP
C     -mp
      INTEGER          IUTILE , IPHAS  , ICLVAR(NDIM) , III
C     -mp
      INTEGER          IPCROM , IPCVST , IFLMAS , IFLMAB , IPCCP, IPCVSL
      INTEGER          IDIMTE , ITENSO , ISCAL
      INTEGER          II     , NBR    , IRANGV , IRANG1 , NPOINT
      INTEGER          IMOM   , IPCMOM , IDTCM
      INTEGER          ITAB(3), IUN
      INTEGER          NCESMP , ICESMP , ISMACP , ITPSMP
      INTEGER          ILELT  , NLELT
C     
      DOUBLE PRECISION XRTPA  , XRTP
      DOUBLE PRECISION XBILAN , XBILVL , XBILPA , XBILPT
      DOUBLE PRECISION XBILSY , XBILEN , XBILSO , XBILDV
      DOUBLE PRECISION XBILMI , XBILMA
      DOUBLE PRECISION EPSRGP , CLIMGP , EXTRAP
      DOUBLE PRECISION XFLUXF , XGAMMA
      DOUBLE PRECISION DIIPBX, DIIPBY, DIIPBZ, SURFBN, DISTBR
      DOUBLE PRECISION VISCT, FLUMAB , XCP , XVSL, CP0IPH, RRR
      DOUBLE PRECISION XYZ(3), XABS, XU, XV, XW, XK, XEPS
C     -mp      
      DOUBLE PRECISION FX, FY, C_D, C_L, CD_NTCABS, T_NTCABS
      DOUBLE PRECISION CD_SUM, CD_BAR, CD_RMS, CD_RMS_SUM
      DOUBLE PRECISION CL_RMS_SUM, CL_SUM, CL_BAR, CL_RMS
      SAVE             CL_RMS_SUM
      SAVE             CD_RMS_SUM
      SAVE             CD_SUM
      SAVE             CL_SUM
      DOUBLE PRECISION rho, DZ, D, V_REF
      INTEGER          ii_ntp, ii_anc, iam
      INTEGER          ICLU, ICLV, ICLW, IDIM
      INTEGER          NCELTT
      DOUBLE PRECISION time, lastime, t_adim
      DOUBLE PRECISION CD_BAR_AM, CD_BAR_ANC, CL_FLUC
      DOUBLE PRECISION PRESS(NFABOR)
C     INTEGER          TIELG(2,NCEL)
C     DOUBLE PRECISION CPMARI
C     -mp
C***********************************************************************
C     
C     
C     
C     
C=======================================================================
C     1. INITIALISATION
C=======================================================================
C     
C     ---> Gestion memoire
C     
      IDEBIA = IDBIA0
      IDEBRA = IDBRA0
C     
C     -mp      
c     
c     
      FX    = 0.D0
      FY    = 0.D0
      C_D   = 0.D0
      C_L   = 0.D0
      CD_BAR = 0.D0
      CD_RMS = 0.D0
      CL_BAR = 0.D0
      CL_RMS = 0.D0
C     CD_BAR_AM = 0.D0
C     CD_BAR_ANC = 0.D0
      CL_FLUC = 0.D0
C      CPMARI = 0.D0
      time = 0.D0
      lastime = 0.D0
      t_adim = 0.D0
c     
c     valeurs fixees 
c     
      DZ    = 5.D-1
      D     = 1.D0
      rho   = 1.026D+3
      V_REF = 7.D0
c     
c
C=======================================================================
C     Observation de la pression autour du profil
C=======================================================================
C     localisation du groupe representant le tube
C     couleur 1 
c      CALL GETFBR('1',NLELT,LSTELT)
C     ===========
C
C Ouverture des fichiers
C
c        IF (ISUITE.EQ.0) THEN
c            IF (NTCABS.EQ.1) THEN 
c               OPEN(60, FILE = 'Pression_user.hst', status='new')
c            ENDIF
c         ELSEIF(ISUITE.EQ.1) THEN
c            IF(NTCABS.EQ.NTPABS+1) THEN
c               OPEN(60, FILE = 'Pression_user.hst', status='unknown',
c     &              POSITION='append')
c            ENDIF
c         ENDIF
C	  
C Ecritures
C
c      WRITE (60,*) 'Pas de temps numero', NTCABS, 'Date', TTCABS
c      DO ILELT = 1, NLELT
c	           IFAC = LSTELT(ILELT)
c				IEL = IFABOR(IFAC)
c		WRITE(60,*) IFAC, RTP(IEL, IPR(1))
c	  END DO
c	  WRITE(60,*) ' '
C
c=======================================================================
c     Calcul des efforts sur le profil
c=======================================================================
c     localisation du groupe representant le tube
c     couleur 1 
      CALL GETFBR('profil',NLELT,LSTELT)
C     ===========
      DO ILELT = 1, NLELT
         IFAC = LSTELT(ILELT)
         FX = FX + RA(IFORBR + NDIM*(IFAC-1))
         FY = FY + RA(IFORBR + NDIM*(IFAC-1) + 1)
      ENDDO
c     
c     Si calcul parallele
c     
      IF(IRANGP.GE.0) THEN
         call PARSOM(FX)
         call PARSOM(FY)
      ENDIF	
c     
c     Transformation en force lineique :
c     
      FX = FX/DZ
      FY = FY/DZ
c     
c     Calcul des coefficients C_D, C_L :
c     
      C_D = FX/(0.5*rho*D*(V_REF)**2)
      C_L = FY/(0.5*rho*D*(V_REF)**2)
c     
c     definition du temps adimensionne : t* = temps courant * Uinfini / D
c     
      t_adim = (TTCABS*V_REF)/D
c     
c======================================================================
c     Ecriture des efforts dans un fichier
c======================================================================
c     -composition fichiers colonne1: NTCABS
c     colonne2: TTCABS
c     colonne3: valeur de la grandeur d'interet 
c     
      
      IF (IRANGP.LE.0) THEN
c     
c     IF (NTCABS.EQ.PDTDEB) THEN  ---> a rajouter si choix de dbut
c     d ecriture different du debut du calcul
c     
         IF (ISUITE.EQ.0) THEN
            IF (NTCABS.EQ.1) THEN 
               OPEN(99, FILE = 'ForceX.hst', status='new')
               OPEN(82, FILE = 'ForceY.hst', status='new')
            ENDIF
         ELSEIF(ISUITE.EQ.1) THEN
            IF(NTCABS.EQ.NTPABS+1) THEN
               OPEN(99, FILE = 'ForceX.hst', status='old',
     &              POSITION='append')
               OPEN(82, FILE = 'ForceY.hst', status='old',
     &              POSITION='append')
            ENDIF
         ENDIF
C     
c--   Frequence d'ecriture dans le fichier = FREQECR
c     IF (MOD(NTCABS,FREQECR).EQ.0) THEN
c     
         WRITE (99,120) NTCABS, TTCABS, 
     &        FX
         call flush(99)
         WRITE (82,120) NTCABS, TTCABS, 
     &        FY
         call flush(82)
c     ENDIF
c     
         IF (NTCABS.EQ.NTMABS) THEN
            
            WRITE(99,*) ' '
            WRITE(82,*) ' '
c     
            CLOSE(99)
            CLOSE(82)
         ENDIF
c     
      ENDIF
c     
c     
c     
c     
c     
c====================================================================================
c     Calcul des coefficients fluctuants Cd, Cl, des RMS correspondants et des moyennes
c     Ecriture dans des fichiers
c====================================================================================
c     -composition fichiers colonne1: NTCABS
c     colonne2: TTCABS
c     colonne3: t* : temps adimensionne t_adim
c     colonne4: valeur de la grandeur d'interet 
c     
      
      IF (IRANGP.LE.0) THEN
c     
c     IF (NTCABS.EQ.PDTDEB) THEN  ---> a rajouter si choix de dbut
c     d'ecriture different du debut du calcul
c     
         IF(ISUITE.EQ.0) THEN  
            IF (NTCABS.EQ.1) THEN 
               OPEN(98, FILE = 'C_D.hst', status='new')
               OPEN(81, FILE = 'C_L.hst', status='new')
               OPEN(97, FILE = 'CD_BAR.hst', status='new')
               OPEN(96, FILE = 'CD_RMS.hst', status='new')
               OPEN(95, FILE = 'CL_BAR.hst', status='new')
               OPEN(94, FILE = 'CL_RMS.hst', status='new')
               OPEN(83, FILE = 'CL_FLUC.hst', status='new')
C    		OPEN(81, FILE = 'Velox_cell.hst', status = 'new')
C    		OPEN(82, FILE = 'Veloy_cell.hst', status = 'new')
C    		OPEN(83, FILE = 'Veloz_cell.hst', status = 'new')
C	       OPEN(89, FILE = 'CP.dat', status='new')
            ENDIF
         ELSEIF(ISUITE.EQ.1) THEN
            IF (NTCABS.EQ.NTPABS+1) THEN
               OPEN(98, FILE = 'C_D.hst', status='old',
     &              POSITION='append')
               OPEN(81, FILE = 'C_L.hst', status='old',
     &              POSITION='append')
               OPEN(97, FILE = 'CD_BAR.hst', status='old',
     &              POSITION='append')
               OPEN(96, FILE = 'CD_RMS.hst', status='old',
     &              POSITION='append')
               OPEN(95, FILE = 'CL_BAR.hst', status='old',
     &              POSITION='append')
               OPEN(94, FILE = 'CL_RMS.hst', status='old',
     &              POSITION='append')
               OPEN(83, FILE = 'CL_FLUC.hst', status='old',
     &              POSITION='append')
C   		OPEN(81, FILE = 'Velox_cell.hst', status = 'new')
C     		OPEN(82, FILE = 'Veloy_cell.hst', status = 'new')
C     		OPEN(83, FILE = 'Veloz_cell.hst', status = 'new')
C     		OPEN(89, FILE = 'CP.dat', status='new')
c     
C
C     Placement des differentes grandeurs etudiees dans un tableau de travail
C
               CL_SUM=RDEVEL(3)*(NTCABS-1)
               CD_SUM=RDEVEL(1)*(NTCABS-1)
               CD_RMS=RDEVEL(2)
               CL_RMS=RDEVEL(5)
               CD_RMS_SUM=RDEVEL(6)
               CL_RMS_SUM=RDEVEL(7)
            ENDIF
         ENDIF

c ---------------CD-----------------------------------------------
c
c 
     	WRITE (98,120) NTCABS, TTCABS, t_adim, 
     &       C_D
      	call flush(98)
c
c-- Moyenne quadratique
c
        CD_SUM = CD_SUM + C_D
c
        CD_BAR = CD_SUM/(NTCABS*1.D0)
c
        WRITE(97,130) NTCABS, TTCABS, t_adim, CD_BAR
c
        RDEVEL(1) = CD_BAR
c
	call flush(97)
c
c-- Calcul RMS
c
        CD_RMS_SUM = CD_RMS_SUM + (C_D - CD_BAR)**2
        CD_RMS     = SQRT(CD_RMS_SUM/(NTCABS*1.D0))
c
        WRITE(96,130) NTCABS, TTCABS, t_adim, CD_RMS
c
        RDEVEL(2) = CD_RMS
        RDEVEL(6) = CD_RMS_SUM
c
	call flush(96)
c
c
c----------------CL---------------------------------------------
c
c
      	WRITE (81,120) NTCABS, TTCABS, t_adim,  
     &       C_L
      	call flush(81)
c
c-- Moyenne quadratique
c
        CL_SUM = CL_SUM + C_L
        CL_BAR = CL_SUM/(NTCABS*1.D0)
        CL_FLUC = C_L - CL_BAR
c
        WRITE(95,130) NTCABS, TTCABS, t_adim, CL_BAR 
c
        RDEVEL(3) = CL_BAR
C
	call flush(95)
c
        WRITE(83,130) NTCABS, TTCABS, t_adim, CL_FLUC 
c
        RDEVEL(4) = CL_FLUC
C
	call flush(83)
c
c	
c-- Calcul RMS
c
        CL_RMS_SUM = CL_RMS_SUM + (C_L - CL_BAR)**2
        CL_RMS     = SQRT(CL_RMS_SUM/(NTCABS*1.D0))
c
        WRITE(94,130) NTCABS, TTCABS, t_adim, CL_RMS
c 
        RDEVEL(5) = CL_RMS
        RDEVEL(7) = CL_RMS_SUM
c
	call flush(94)
      END IF
c      
      call flush(81)
      call flush(82)
      call flush(83)
c     
C
      IF(IRANGP.LE.0) THEN
         IF (NTCABS.EQ.NTMABS) THEN
            WRITE(98,*) ' '
            WRITE(81,*) ' '
            WRITE(97,*) ' '
            WRITE(96,*) ' '
            WRITE(95,*) ' '
            WRITE(83,*) ' '
            WRITE(94,*) ' '
C            WRITE(81,*) ' '
C            WRITE(82,*) ' '
C            WRITE(83,*) ' '
C	    WRITE(89,*) ' '

c     
            CLOSE(98)
            CLOSE(81)
            CLOSE(97)
            CLOSE(96)
            CLOSE(95)
            CLOSE(83)
            CLOSE(94)
C            CLOSE(81)
C            CLOSE(82)
C            CLOSE(83)
C	    CLOSE(89)
         ENDIF
c     
      ENDIF

c     
 5110 FORMAT(i8,i8,10000(4x,E14.5))      
c     
c     
c     
c     
c     
 120  FORMAT(i8,197(3x,E14.8))      
c     
 130  FORMAT(i8,197(2x,E14.8))
c     
c======================================================================
c     FIN
c======================================================================
c     
c     
c     

      RETURN
      END
c@z
